package org.drools.mongodb.persistence;

import org.apache.log4j.Logger;
import org.drools.KnowledgeBase;
import org.drools.marshalling.Marshaller;
import org.drools.marshalling.MarshallerFactory;
import org.drools.runtime.KnowledgeSessionConfiguration;
import org.drools.runtime.StatefulKnowledgeSession;

import com.s2grupo.triton.context.AppContext;
import com.s2grupo.triton.service.CorrelatorService;

/**
 * Clase base para los serializadores
 * deserializadores de la WM.
 * 
 * @author nsabic
 *
 */
public abstract class AbstractStateMarshaller {
	
	protected StatefulKnowledgeSession ksession;
	protected KnowledgeSessionConfiguration kconf;
	protected Marshaller marshaller;
	
	protected Integer sessionId;
	
	protected static final Logger logger = Logger.getLogger(AbstractStateMarshaller.class);
	
	protected StateOps stateOps = AppContext.getStateOps();
	
	public AbstractStateMarshaller(Integer sessionId, 
								   StatefulKnowledgeSession ksession, 
								   KnowledgeSessionConfiguration conf ) {
		this.ksession = ksession;
		this.kconf = conf;
		this.sessionId = sessionId;
		
		this.marshaller = MarshallerFactory.newMarshaller( ksession.getKnowledgeBase() );
	
	}
	
	public AbstractStateMarshaller(Integer sessionId,
	        					   KnowledgeBase kbase, 
	        					   KnowledgeSessionConfiguration conf) {

		this.kconf = conf;
		this.marshaller = MarshallerFactory.newMarshaller( kbase ) ;
		this.sessionId = sessionId;
	}
}
