package org.drools.mongodb.persistence;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;

import org.apache.log4j.Logger;
import org.drools.marshalling.Marshaller;
import org.drools.runtime.KnowledgeSessionConfiguration;
import org.drools.runtime.StatefulKnowledgeSession;

public class DroolsMarshallingUtils {
	
	private static final Logger logger = Logger.getLogger(DroolsMarshallingUtils.class);
	
	public static byte[] marshall(Marshaller marshaller, StatefulKnowledgeSession ksession) {
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		try {
			marshaller.marshall(baos, ksession);
		} catch (IOException e) {
			logger.error("Error marshalling session", e);
		}
		return baos.toByteArray();
	}
	
	
	public static StatefulKnowledgeSession unmarshall(byte[] ks, Marshaller marshaller, KnowledgeSessionConfiguration ksconf) {
		ByteArrayInputStream bais = new ByteArrayInputStream(ks);
		StatefulKnowledgeSession ksession = null;
		try {
			ksession = marshaller.unmarshall(bais, ksconf, null);
		} catch (IOException e) {
			logger.error("Error unmarshalling session", e);
		} catch (ClassNotFoundException e) {
			logger.error("Error unmarshalling session", e);
		}
		return ksession;
	}
}
