package org.drools.mongodb.persistence;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import org.drools.runtime.KnowledgeSessionConfiguration;
import org.drools.runtime.StatefulKnowledgeSession;

import org.drools.mongodb.persistence.CorrelatorService;
import org.drools.mongodb.persistence.AbstractStateMarshaller;
import org.drools.mongodb.persistence.DroolsMarshallingUtils;
import org.drools.mongodb.persistence.StateOutputMarshaller;


public class StateOutputMarshallerImpl extends AbstractStateMarshaller implements StateOutputMarshaller {
	
	private ExecutorService executor = Executors.newFixedThreadPool(3);
	
	public StateOutputMarshallerImpl(  
								    StatefulKnowledgeSession ksession, 
							        KnowledgeSessionConfiguration conf ) {
		super(ksession, conf);
	}
	
	@Override
	public void marshall() {
		
				executor.execute(new Runnable() {
					@Override
					public void run() {
						
						byte[] ks = DroolsMarshallingUtils.marshall(marshaller, ksession);
						
						stateOps.update(sessionId, ks);
					} 
			  });
		 
	}

	@Override
	public void init() {
		byte[] ks = DroolsMarshallingUtils.marshall(marshaller, ksession);
		stateOps.persist(sessionId, ks);
	}
}
